code	segment	'code'
	assume	cs:code,ds:code

	org	2ch
envseg	label	word			; pointer to env seg

	org	100h
start:	jmp	near ptr init		; jump to install routine
	dw	0

new13:	cmp	ax,0408h		; verifying eight sectors?
	jne	start
	cmp	cx,2701h		; sector 1 / cylinder 39?
	jne	start
	or	dx,dx			; drive 0 / head  0?
	jne	start

	sti				; enable interrupts
	push	ds
	xor	ax,ax
	mov	ds,ax
	cmp	byte ptr[7bh],0f0h	; INT 1Eh points below BIOS area?
	pop	ds
	jnb	err
	mov	ax,0008h		; success result
	clc
	jmp	exit
err:	mov	ax,0400h		; error result
	stc
exit:	retf	2

init:	mov	ax,3513h		; create jump to old handler
	int	21h
	inc	byte ptr start
	mov	word ptr start+1,bx
	mov	word ptr start+3,es

	mov	dx,offset new13		; hook into chain
	mov	ah,25h
	int	21h

	mov	es,envseg		; free env seg
	mov	ah,49h
	int	21h

	mov	dx,0013h		; terminate with DX paras resident
	mov	ax,3100h
	int	21h

code	ends

	end	start
